<?php
/***************************************************************************
                  NemoExplorer PHP Script, by Bogar "Eddie" Boris
                             -------------------

   filename             : nemo.php
   version              : 0.3
   date                 : October 13, 2004

   copyright            : Copyright (C) 2002-2004 Bogar Boris
   license              : GNU General Public License (GPL)

   website & forum      : http://eddie.promisestudios.net
   e-mail               : eddie [at] promisestudios [dot] net


   NemoExplorer PHP Script is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   NemoExplorer PHP Script is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 ***************************************************************************
   
   File Version History:
     13-11-2004
     		+ $Filter con suporto ai pattern
        + $HideFile con supporto ai pattern *,?
   
     13-11-2004 - Version 0.3
        -  Initial Alpha releae.
 
 
 ***************************************************************************/
//http://it.php.net/fnmatch



class GetDir
{
	var $ContentFile; // Array  - Il contenuto dei file nella directori.
	var $ContentDir;  // Array  - Il contenuto delle directori nella dir.
	var $path;				// String - Directori da cui prelevare il contenuto.
	var $ShowHidden;	// bool   - Se true mostra anche i file nascosti. (Implementare da un'altra parte ? no)
	var $GlobalStat;  // Array  - Contiene informazioni sui totali.
										// [0][0] = Numero delle directori presenti.
										// [1][0] = Numero totale di files.
										// [1][1] = Numero totale di bytes occupati dal file.
	var $SortBy;			// array  - Opzione su come ordinare i file (array($colonna,$ordine);) $colonna=Numero della colonna. $ordine=0 ASC 1= DESC
	var $DateFormat;	// string - Formatta le date dei file in accordo con la funzione date() del php
	var $FileSize;		// string - Valori Fs in output "auto"-"k"-"m"-"g"
	var $TotalSize;		// String - Setta L'unit per il conteggio totale (vedi $FileSize ).
	var $HideFile;		// Array  - 
	var $Filter;			// String -
	
	
	// Funzione principale da richiamare.
	function FetchDir() {
		if(!isset($this->path)){$this->path = dirname($_SERVER['SCRIPT_FILENAME']);}
		if(!$this->ReadD()){return false;}
		if(!$this->BuildList()){return false;}
		if(isset($this->SortBy)){
			if(!$this->sort($this->SortBy[0],$this->SortBy[1])){return false;}
		}
		return true;
	}
	
	// Funzione di init (al momento inutilizzata).
	function GetDir() {
		//$this->GlobalStat = array("dir","files");
		//$this->GlobalStat[0][0] // N Totale delle directori
		//$this->GlobalStat[1][0] // N Totale dei file.
		//$this->GlobalStat[1][1] // N Totale di byte occupati da tutti i file (disponibile solo dopo aver fatto il BuildList();
	}
	
	function BuildList(){
		//$this->ReadD();
		
		//Appendo all'array contenente la lista dei file le loro propriet.
		for ($k=0;$k<= count($this->ContentFile)-1;$k++){
			$stat = $this->GetFileInfo($this->ContentFile[$k]);		//Prende le stat() del file
			$stat["Name"] = $this->ContentFile[$k];
			$this->GlobalStat[1][1] = $this->GlobalStat[1][1] + $stat["Size"];
			$this->ContentFile[$k] = $stat;
			$this->ContentFile[$k]["HtmlName"] = htmlspecialchars($this->ContentFile[$k]["Name"]);
			
		}
		
		$this->GlobalStat[1][1] = $this->size_unit($this->GlobalStat[1][1],"k");
		$this->GlobalStat[0][0] = count($this->ContentDir);

		//Stessa cosa per le directory
		for ($k=0;$k<= count($this->ContentDir)-1;$k++){
			$stat = $this->GetFileInfo($this->ContentDir[$k]);		//Prende le stat() del file
			$stat["Name"] = $this->ContentDir[$k];
			$this->ContentDir[$k] = $stat;
			$this->ContentDir[$k]["HtmlName"] = htmlspecialchars($this->ContentDir[$k]["Name"]);
		}
		
		return true;
	}



	//Funzione per ordinare degli array multidimensionali.
	function array_sort($matrice, $colonna,$ordine,$Flag=SORT_REGULAR){
		$TmpArray 		= array();
		$ResultArray 	= array();
		$Index 			= 0;
		
		foreach ($matrice as $Value){
			$TmpArray[$Index++] = $Value[$colonna];
		}
		if ($ordine){arsort($TmpArray,$Flag);}else{asort($TmpArray,$Flag);}
		
		$Index = 0;
		while (list ($key, $val) = each ($TmpArray)){
			$ResultArray[$Index++] = $matrice[$key];		
		}
		
		return $ResultArray;
	}
	
	
	// Ordina gli array.
	function sort($colonna, $ordine){
		//Se gli array sono vuoti non esegue il sort.
		if (is_array($this->ContentFile))
			$this->ContentFile = $this->array_sort($this->ContentFile, $colonna, $ordine);
		if (is_array($this->ContentDir))
			$this->ContentDir  = $this->array_sort($this->ContentDir, $colonna, $ordine);
		return true;
	}



	// Legge il contenuto della directori specificato in $this->path
	function ReadD(){
		if (!isset($this->Filter)){$this->Filter = "*.*";}
		$this->Filter = $this->filePattern($this->Filter);
		
		if (!isset($this->ShowHidden))$this->ShowHidden = false;
		if (isset($this->path)){
			if ($dir = @opendir($this->path)) {
	  		while (false !== ($file = readdir($dir))){
	   			if ($file != "." && $file != "..") {					//Elimina dalla lista le voci "."  ".."
	   				if($this->IsHidden($file) == false || $this->ShowHidden == true){
		   				if (is_file($this->path . "/" . $file)){		//Separa in due array diversi le directory dai file.	
		   					if ($this->match_pattern($file, $this->Filter)){		// Filtra i file se  richiesto.
		   						$this->ContentFile[] = $file;
		   						$this->GlobalStat[1][0] = $this->GlobalStat[1][0] + 1;
		   					}
		   				}else{
		   					$this->ContentDir[] = $file;
		   					$this->GlobalStat[0][0] = $this->GlobalStat[0][0] + 1;
		   				}
	   				}
					}
	  		}
	  	closedir($dir);
			}else{
				return false;
			}
		}else{
			return false;
		}
		return true;
	}

	//Restituisce informazioni su un file
	function GetFileInfo($file){
		//mode restituisce un valore ottale
		//$info = array("size","mtime","mode"
		$stat = stat($this->path . "/" . $file);
		
		if (is_dir($this->path . "/". $file)){
			$ext = "dir";
		}else{
			$ext = strtolower($this->get_ext($file));
		}
		
		//Forse stanno meglio fuori >"<
		if (!isset($this->DateFormat)){
			$datet = strftime("%d/%b/%Y %H:%M", $stat["mtime"]);
		}else{
			//$datet = date($this->DateFormat, $stat["mtime"]);
			$datet = strftime($this->DateFormat, $stat["mtime"]);
		}
		/*
		if (!isset($this->FileSize)){
			$SUnit = $this->size_unit($stat["size"]);
		}
		*/
		$mode = substr(base_convert($stat["mode"], 10, 8), (strlen(base_convert($stat["mode"], 10, 8)) - 3));

		/*
		$stat = array(
			"",
			$stat["size"],
			$this->IsHidden($file),
			$ext,
			$mode,
			$stat["mtime"],
			$datet,
			$this->size_unit($stat["size"], $this->FileSize)
		);		
		*/
		
		$stat = array(
			"Name"		=> "",
			"Size"				=> $stat["size"],
			"IsIdden"			=> $this->IsHidden($file),
			"Ext"					=> $ext,
			"Permission"	=> $mode,
			"LastMod"		=> $stat["mtime"],
			"FormatDate"	=> $datet,
			"FileSize"		=> $this->size_unit($stat["size"], $this->FileSize)
		);
		return $stat;
		
	}
	

	function filePattern($pattern){
		$search  =	array ("\*",	"\?");
		$replace = array ("[.]*",".");
		if (is_array($pattern)){
			for ($k=0; $k<= count($pattern)-1; $k++){
					$out[$k] = str_replace($search,$replace,preg_quote($pattern[$k]));
				}
		}else{
			$out = str_replace($search,$replace,preg_quote($pattern));
		}
		
		return $out;
	}
	
	function match_pattern($name, $pattern){

		if (is_array($pattern)){
			foreach ($pattern as $patt){
				if (preg_match("/^".$patt."$/i",$name)){
					return true;
				}
			}
			return false;
		}else{
			if (preg_match("/".$pattern."/",$name)){
				return true;
			}
		}
		return  false;
	}


//Restituisce true se il file indicato  un file nascosto.
	function IsHidden($file){
		static $hidden;
		$hidden = $this->filePattern($this->HideFile);
		
		if ($file[0] == ".") {
			return 1;
		}else{
			if (isset($this->HideFile)){
				if ($this->match_pattern($file,$hidden)){
					return 1;
				}
			}
			return 0;
		}
	}
	
	// Ritorna l'estensione di un file.
	function get_ext($file_name){
		$file_name = strtolower($file_name);
		$file_name = explode(".", $file_name);
		return $file_name[count($file_name) -1];
	}
	
	
	// Scala le unit di misura.
	function size_unit($size, $auto = true){
		$auto = strtolower($auto);
		if (!$auto) $auto = true;

		if($auto == "b"){
			$val = $size. " Bytes";
		}elseif($auto == "k"){
			$val = $this->dotSize(round($size / 1024)) . " KB";
			if ($val == "0 KB"){$val = $size. " Bytes";}
		}elseif ($auto == "m"){
			$val = $this->dotSize(round($size / 1048576)) . " MB";
		
		}elseif ($auto == "g"){
			$val = $this->dotSize(round($size / 1073741824)) . " GB";
		
		}elseif ($auto == true){
				if($size >= 1073741824){
					$size = $this->dotSize(round($size / 1073741824)) . " GB";
	
				}elseif($size >= 1048756){
					$size = $this->dotSize(round($size / 1048576)) . " MB";
				
				}elseif($size >= 1024){
					$size = $this->dotSize(round($size / 1024)) . " KB";
				
				}else{
					$size=$size . " Bytes";
				}
			$val = $size;
		}
		return $val;
	}


	// Agiunge i punti (.) nei filesize
	function dotSize($size){
		$size = strrev($size);
		$x = 0;
		
		for ($k=0;$k<=strlen($size)-1;$k++){
			$out .= $size[$k];
			if ($x == 2){$x = 0; $out .= ".";}else{$x++;}
			
		}
		$out = strrev($out);
	
		if ($out[0] == "."){$out = substr($out,1);}
		return $out;
	}
	
}
/*
$get = new GetDir();
//$get->path = "../";
$get->ShowHidden = true;
$get->SortBy = array(0,1);
$get->FetchDir();

echo "<pre>";
print_r($get->ContentFile);
*/
?>