<?php
/*
--------------------------------------------------------------
 FALCON v1.4.3 - Ultralight Content Managment (xml&class)
                        [ O M E G A ]
 
 version			:	0.5 - beta

 description		:	This is a gallery class.

 project chief:			Carlo Antonio Denaro a.k.a. Blackout
						<blackout AT grayhats DOT org>

 web				:	http://www.promisestudios.it/

 28.04.06			> 	add YouTube.com video support for podcast
--------------------------------------------------------------
*/


/** --
	falcon_gallery
	classe che si occupa di stampare una galleria.
-- */
class falcon_gallery extends base 
{
	var $gallPath;					// Path of gallery
	var $thumbList;					// List of thumbnails
	var $thumbListDescr= array();	// List of thumbnails' Description /!\
	var $catList;					// List of cat
	var $dataFormat;				// Data Out
	var $_countThumbs=0;			// number of images
	var $_countYouTube=0;			// number of youtube video

	/** --
		param galleryPath 		path of gallery
		param dataformat		format of data
	-- */
	function falcon_gallery ( $galleryPath, $dataformat )
	{
		$this->dataFormat =	$dataformat;						// data format
		$this->gallPath =	$galleryPath;						// relative path
		$dir =				$this->getDir($galleryPath, 4);		// get all elements
		$this->thumbList =	$this->selectThumb($dir[0]);		// files | thumb
		$this->catList =	$dir[1];							// categories
		unset($dir);
	}
	// select only thumb
	function selectThumb ( $array )
	{
		if ( !empty($array) )
		{
			foreach ( $array as $a )
			{
				$a= split("\.", $a);							// split by "." regexp
				if ($a[1]=="tb")								// if thumbnail : image.tb.jpeg
				{
					$last[]=$a[0].".".$a[1].".".$a[2];			// add a final array
					$b= split("-", $a[0]);
					$this->thumbListDescr[].=$this->TicTime($b[0])." <br/> ".$b[1]; //add in array
					$this->_countThumbs++;						// increase counter image
				}
				elseif ($a[1]=="yt") {							// YouTube support
					$last[]="http://img.youtube.com/vi/".$a[0]."/2.jpg/".$a[2];  // edit by allanon
					$this->thumbListDescr[].="video from <br/> <a href=\"http://www.youtube.com\">YouTube.com</a>";
					$this->_countYouTube++;						// increase counter youtube video
				}
			}
			return $last;						// return
		}
	}
	// add image in current path
	function addImg( $image, $descr, $data, $dir )
	{
		if ( !empty($dir) )		$dir.="/";
		$name= ereg_replace("[/|:| ]", "", $data)."-".ereg_replace("[.|-| ]", "_", $descr);
		if ( @copy($image['tmp_name'], "etc/gallery/".$dir.$name.".jpg" ) )
			$temp.= ' Image (great) uploaded.';
		$imgfile= "etc/gallery/".$dir.$name.".jpg";
		@list($width, $height) = @getimagesize($imgfile);
		$origimg = @imagecreatefromjpeg($imgfile);
		$nh= 60; $nw= $width*$nh/$height;
		$cropimg = @imagecreatetruecolor($nw,$nh);
		@imagecopyresampled ( $cropimg, $origimg, 0, 0, 0, 0, $nw, $nh, $width, $height  );
					
		if ( @Imagejpeg($cropimg, $this->gallPath.$name.".tb.jpg") )
			$temp.= ' Immagine (thumb) correttamente inserita.';
						
		imagedestroy($cropimg); imagedestroy($origimg);
		return $temp;
	} // --
	function addVid ( $video, $dir ) { #image suppressed
		if ( !empty($dir) )		$dir.="/";
		$vd= split("=", $video);
		// crea file vuoto con informazioni sul video
		$fd= fopen( "etc/gallery/".$dir.$vd[1].".yt", "w+"); //edit by allanon
			if ( fwrite($fd, " ") )		$temp.=' video added ';
		fclose($fd);
		
		return $temp;
	} // -- addVid
	function countThumb()
	{	//return (count($this->thumbList)); 				mod 28.04.06 - old version are deprecated
		return $this->_countThumbs;
	}
	function countVideo() {
		return $this->_countYouTube;
	}
	function countCat()
	{	return (count($this->catList)); }
	function TicTime($tic)
	{
		list($year,$month,$day,$hour,$minute,$seconds) = sscanf($tic,'%4s%2s%2s%2s%2s%2s');
		return date($this->dataFormat, mktime($hour,$minute,$seconds,$month,$day,$year));
	}
	// --
}

?>
