<?php
/*
--------------------------------------------------------------
 FALCON v1.4.3 - Ultralight Content Managment (xml&class)
                        [ O M E G A ]
 
 version		:		1.0 - stable

 description	:		This is a news class.

 project chief:			Carlo Antonio Denaro a.k.a. Blackout
						<blackout AT grayhats DOT org>
 project coder:			Bogar Boris a.k.a. Eddie
 						<eddie AT promisestudios DOT net>

 web				http://www.promisestudios.it/

 updates			:
 
 > 04/11/04
				- added funct select first thm
 > 18/12/04
				- added row fot page order (array)
 > 28/12/04
				- modify sort on page array
 > 01/01/05
				- added 1 level section
 > 06/01/05
				- added php executable managment
 > 12/04/05
				- clean code & optimize it
 > 24/07/05
				- Resolv bug 0001-dg-05

TODO
	
 > Passage to php5:  create a abstract class for list
 
--------------------------------------------------------------
*/



// ---
// Error handler
//
function falcon_error_handler ($errno){
    $error_handler_msg= array ("0"=>"WARNING: the default theme ".$default_template." was not found.",
                                "1"=>"WARNING: the index file of ".$default_template." was not found."
                                );
    die( "[!] :ERRNO [ ".$errno." ] ".$error_handler_msg[$errno] );
}
// ---  end .. func



// ---
// Base class
//
class base
{
	/**
	 * Description of the Variable
	 * @var		mixed
	 * @access	public
	 */
	var $count;
	//
	// List func | 1 = files 2 = folders 3 = all 4 = array(files, Folders)
	//
	function getDir($DirPath, $get = 1)
	{
		if($dir = opendir($DirPath))
		{
			while (($file = readdir($dir)) !== false)
			{
				if($file != "." && $file != ".." ) 		// add from - blackout 26.02.06
				{
					if (is_file($DirPath . "/" . $file))
					{
						$files[] = $file;	
					}else{
						$folders[] = $file;	
					}
					$all[] = $file;
					$this->count++;				// add from - blackout 26.02.06
				} // --
			} // -- end while
			closedir($dir);
			switch($get)
			{
				case 1:
					if (is_array($files)) 		sort($files);
					return $files;
				break;
				case 2:
					if (is_array($folders)) 	sort($folders);
					return $folders;
				break;
				case 3:
					if (is_array($all))		sort($all);
					return $all;
				break;
				case 4:
					if (is_array($files)) 		sort($files);
					if (is_array($folders)) 	sort($folders);
					return array($files, $folders);
				break;
			} # end switch
		}
	} 
	# --

	#
	# Get content of file
	#
	function readFile($file)
	{
		return file_get_contents($file);
	}
	# --
	
	#
	# Get extension of file
	#
	function _GetExt($file_name)
	{
		$file_name = strtolower($file_name);
		$file_name = explode(".", $file_name);
		return $file_name[count($file_name) -1];
	}
	# --
	
	#
	# Get name of file
	#
	function _GetName($file_name)
	{
		$file_name = strtolower($file_name);
		$file_name = explode(".", $file_name);
		return $file_name[0];
	}
	# --
	
}
# ---



# ---
# Template class | extends base
#
class template extends base
{
	var $TemplateDir;			# Working Directory
	var $TemplateList;		# All templates list
	var $FirstTemplate;		# First template
	var $UsedTemplate;  	# Template Code
	
	
	# Costruttore, Legge la lista dei template disponibili (Chiamiamo in auto GetTemplate ?)
	function template($TemplateDir)
	{
		$this->TemplateDir = $TemplateDir;
		$folders = $this->GetDir($this->TemplateDir,2);
		
		foreach ($folders as $dir)
		{
			if (file_exists($this->TemplateDir . "/" . $dir . "/index.htm"))
			{
				$this->TemplateList[] = $dir;
				if (!isset($this->FirstTemplate)) $this->FirstTemplate = $dir;
			}
		}
	}
	
	# Load template
	function GetTemplate($skin)
	{
		$this->UsedTemplate = $this->readFile($this->TemplateDir . "/" . $skin . "/index.htm");		
	}
	
	# Sobstitute keyword on template
	function ereg_template ($search, $sobstitute){
		$this->UsedTemplate = str_replace($search, $sobstitute, $this->UsedTemplate);
	}

}


class pages extends base 
{
	var $PagesPath;		# Path dove cercare le pagine
	var $PageList;		# Lista delle pagine disponibili
	var $SectionList;	# Lista delle sezioni disponibili
	var $body;				# Part of pages
	var $title;				# Part of pages
	var $url;					# Part of pages
	var $isphp = false;	# BOOLEAN: If this page is executable
	
	# Costruttore, carica in memoria la lista delle pagine.
	function pages($PagesPath)
	{
		$this->PagesPath = $PagesPath;
		$dir =  $this->getDir($PagesPath,4);
		$this->PageList = $dir[0];				# files
		if ( basename($PagesPath)=="pages")				# add check - bug 0001-dg-05 - blackout
			$this->SectionList = $dir[1];		# folders
		unset($dir);
	}
	
	function getPageData($page)
	{	
   		if ($this->_GetExt($page) == "php")
		{
			# remove weight from pagename
			$pageName = $this->_GetName($page);
			$pageName = preg_replace("/^[0-9]{3}_/","",$pageName);
			
			$this->title = $pageName;
			$this->url= "";
		}
		else
		{
			$FileHandler = fopen($this->PagesPath . $page, "r");
			$b = split("@", @fgets($FileHandler));
			$this->title = $b[0];
			$this->url = $b[1];
			fclose($FileHandler);
		}
	}
		
	function GetPage($page)
	{
   		if ($this->_GetExt($page) == "php")
		{
			$this->isphp = true;
			$this->_phpPage($page);
		}
		else
		{
			$this->isphp = false;
			$this->_htmlPage($page);
		}
	}
	
	function _phpPage($page)
	{	
		# remove weight from pagename
		$pageName = $this->_GetName($page);
		$pageName = preg_replace("/^[0-9]{3}_/","",$pageName);
		
		$this->title = $pageName."|";
		$this->url= "";
		$this->body = $this->PagesPath . $page;
	}
	
	function _htmlPage($page)
	{
		if (is_file($this->PagesPath . $page))
		{
			$FileHandler = fopen($this->PagesPath . $page, "r");
			$b = split("@", @fgets($FileHandler));
			$this->title = $b[0];
			$this->url = $b[1];
			$this->body = fread($FileHandler, filesize($this->PagesPath . $page));
			fclose($FileHandler);
		}
		else
		{
			$this->body= "Trying to ack? SORRY but this file not exist ".$this->PagesPath." ".$page;
		}
	}
}



class module extends base 
{
	var $ModuleList;
	var $ModuleName;
	var $ModuleDir;
	
	function module($folder)
	{
		$this->ModuleDir = $folder;
		$this->ModuleList = $this->getDir($this->ModuleDir);
	}
	
	function LoadModule($module)
	{
		include($this->ModuleDir . $module);	
	}
}

/*
--------------------------------------------------------------
   2007 (C) PROMISE STUDIOS www.promisestudios.it
--------------------------------------------------------------
*/
?>
